import * as THREE from 'three';
type UniformMap = {
    [uniform: string]: THREE.IUniform<any>;
};
export declare class ShadertoyTexture {
    width: number;
    height: number;
    texture: THREE.Texture;
    image: BufferShader;
    bufferA: BufferShader;
    bufferB: BufferShader;
    bufferC: BufferShader;
    bufferD: BufferShader;
    uniforms: UniformMap;
    clock: THREE.Clock;
    set common(value: string);
    constructor(width: number, height: number);
    render(renderer: THREE.WebGLRenderer): void;
}
export declare class BufferShader {
    width: number;
    height: number;
    common: string;
    outputBuffer: THREE.WebGLRenderTarget;
    readBuffer: THREE.WebGLRenderTarget;
    iChannel: (THREE.Texture | BufferShader)[];
    private iChannel0Config;
    private iChannel1Config;
    private iChannel2Config;
    uniforms: {
        iChannel0: {
            value: THREE.Texture;
        };
        iChannel1: {
            value: THREE.Texture;
        };
        iChannel2: {
            value: THREE.Texture;
        };
        iChannel3: {
            value: THREE.Texture;
        };
    };
    camera: THREE.OrthographicCamera;
    scene: THREE.Scene;
    enabled: boolean;
    plane: THREE.Mesh<THREE.PlaneGeometry, THREE.Material | THREE.Material[]>;
    set shader(value: string);
    constructor(width: number, height: number);
    swap(): void;
    private getIChannel;
    render(renderer: THREE.WebGLRenderer): void;
}
export {};
